import { tpl } from "./tpl.js";
import events from "./events.js";
import * as game from "./game.js";

const clear = player => {
  const _player = game.stackables.get(player);
  _player.pile.forEach((slots, slotid) => {
    document.querySelector(`#player${_player.id}_pile_slot_${slotid}`).innerHTML = "";
  });
  if(_player.id === 0) {
    _player.hand.forEach((slots, slotid) => {
      document.querySelector(`#player${_player.id}_hand_slot_${slotid}`).innerHTML = "";
    });
  }
};
const clearMain = () => {
  game.mainstack.forEach((cards, slotid) => document.querySelector(`#mainstock_pile_slot_${slotid}`).innerHTML = "");
};

export const render = player => {
  console.log(`render ${player}`);
  clear(player);
  const _player = game.stackables.get(player);
  document.querySelector(`#player${_player.id}_name`).innerHTML = player.toString();
  if(_player.pile) {
    _player.pile.forEach((slots, slotid) => {
      slots.forEach(card => {
        document.querySelector(`#player${_player.id}_pile_slot_${slotid}`).insertAdjacentHTML("beforeend",
          [{ val: card.val, draggable: _player.id === 0 }].map(card.type === "joker" ? tpl.joker : tpl.card).join``
        );
      });
    });
  }
  if(_player.hand) {
    _player.hand.forEach((card, slotid) => {
      document.querySelector(`#player${_player.id}_hand_slot_${slotid}`).insertAdjacentHTML("beforeend",
        [{ val: card.val, draggable: _player.id === 0 }].map(card.type === "joker" ? tpl.joker : tpl.card).join``
      );
    });
  }
  if(_player.stock) {
    _player.stock.forEach(card => {
      console.log(card);
      document.querySelector(`#player${_player.id}_stock`).insertAdjacentHTML("beforeend",
        [{ val: card.val, draggable: _player.id === 0 }].map(card.type === "joker" ? tpl.joker : tpl.card).join``
      );
    });
  }
  events.createCardEvents();
};
export const renderMain = () => {
  console.log("render Main");
  clearMain();
  game.mainstack.forEach((cards, slotid) => {
    cards.forEach(card => {
      document.querySelector(`#mainstock_pile_slot_${slotid}`).insertAdjacentHTML("beforeend",
        [{ val: card.val }].map(card.type === "joker" ? tpl.joker : tpl.card).join``
      );
    });
  });
};
export const renderAll = () => {
  game.stackables.forEach((e, player) => render(player));
  renderMain();
};
