import { msgBox, removeAllmsgBox } from "./tpl.js";
import * as game from "./game.js";
import * as render from "./render.js";

let socket = false;
let _playername;
let _gameroom;

export const connect = ({ playername, gameroom = "default" }) => {
  // checks
  if(playername < 3 || gameroom < 3)
    return false;

  [_playername, _gameroom] = [playername, gameroom];
  if(socket) {
    socket.disconnect();
    socket = false;
  }
  socket = io();
  socketevents();
};

const socketevents = () => {
  socket.on("auth", () => {
    socket.emit("player", {
      playername: _playername,
      gameroom: _gameroom
    });
  });
  removeAllmsgBox();
  msgBox("waitforPlayer");
  socket.on("playerlist", player => {
    document.querySelector("span#wfp_players").innerHTML = player.join("<br />") + `<a href="#" id="start">start</a>`;
    document.querySelector("a#start").addEventListener("click", () => {
      socket.emit("start");
    });
  });
  socket.on("gamestart", _game => {
    removeAllmsgBox();
    document.querySelector("#menu").style.display = "none";
    document.querySelector("#black").style.display = "none";

    render.renderAll();
    _game.player.forEach((player, i) => {
      game.stackables.set(player[0], new game.player(i));
      const _player = game.stackables.get(player[0]);
      _player.id = i;

      if(i === 0) {
        player[1].cards.hand.forEach(card => {
          _player.hand.push(new game.card({ type: card === 13 ? "joker" : "normal", val: card === 13 ? "" : card }));
        });
      }
      player[1].cards.stock.forEach(card => {
        _player.stock.push(new game.card({ type: card === 13 ? "joker" : "normal", val: card === 13 ? "" : card }));
      });

      render.renderAll();
    });

  });
};